/* This file was generated by: gen/gen.exe c */

#include "common.h"

#if defined(_WIN32)

NA(openat);
NA(faccessat);
NA(fchmodat);
NA(fchownat);
NA(mkdirat);
NA(unlinkat);
NA(mkfifoat);
NA(linkat);
NA(renameat);
NA(symlinkat);

#else /* defined(_WIN32) */

CAMLprim value shexp_has_openat() { return Val_true; }

CAMLprim value shexp_openat(value v_dir, value v_path, value v_flags, value v_perm)
{
  CAMLparam4(v_dir, v_path, v_flags, v_perm);
  int dir;
  char* path;
  int flags;
  int perm;
  int fd;

  caml_unix_check_path(v_path, "openat");
  dir   = Int_val(v_dir);
  path  = caml_stat_strdup(String_val(v_path));
  flags = caml_convert_flag_list(v_flags, shexp_open_flag_table);
  perm  = Int_val(v_perm);

  caml_enter_blocking_section();
  fd = openat(dir, path, flags, perm);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (fd == -1) uerror("openat", v_path);
  CAMLreturn(Val_int(fd));
}

CAMLprim value shexp_has_faccessat() { return Val_true; }

CAMLprim value shexp_faccessat(value v_dir, value v_path, value v_mode, value v_flags)
{
  CAMLparam4(v_dir, v_path, v_mode, v_flags);
  int dir;
  char* path;
  int mode;
  int flags;
  int res;

  caml_unix_check_path(v_path, "faccessat");
  dir   = Int_val(v_dir);
  path  = caml_stat_strdup(String_val(v_path));
  mode  = caml_convert_flag_list(v_mode, shexp_access_permission_table);
  flags = caml_convert_flag_list(v_flags, shexp_at_flag_table);

  caml_enter_blocking_section();
  res = faccessat(dir, path, mode, flags);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (res == -1) uerror("faccessat", v_path);
  CAMLreturn(Val_unit);
}

CAMLprim value shexp_has_fchmodat() { return Val_true; }

CAMLprim value shexp_fchmodat(value v_dir, value v_path, value v_perm, value v_flags)
{
  CAMLparam4(v_dir, v_path, v_perm, v_flags);
  int dir;
  char* path;
  int perm;
  int flags;
  int res;

  caml_unix_check_path(v_path, "fchmodat");
  dir   = Int_val(v_dir);
  path  = caml_stat_strdup(String_val(v_path));
  perm  = Int_val(v_perm);
  flags = caml_convert_flag_list(v_flags, shexp_at_flag_table);

  caml_enter_blocking_section();
  res = fchmodat(dir, path, perm, flags);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (res == -1) uerror("fchmodat", v_path);
  CAMLreturn(Val_unit);
}

CAMLprim value shexp_has_fchownat() { return Val_true; }

CAMLprim value shexp_fchownat(value v_dir, value v_path, value v_uid, value v_gid, value v_flags)
{
  CAMLparam5(v_dir, v_path, v_uid, v_gid, v_flags);
  int dir;
  char* path;
  int uid;
  int gid;
  int flags;
  int res;

  caml_unix_check_path(v_path, "fchownat");
  dir   = Int_val(v_dir);
  path  = caml_stat_strdup(String_val(v_path));
  uid   = Int_val(v_uid);
  gid   = Int_val(v_gid);
  flags = caml_convert_flag_list(v_flags, shexp_at_flag_table);

  caml_enter_blocking_section();
  res = fchownat(dir, path, uid, gid, flags);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (res == -1) uerror("fchownat", v_path);
  CAMLreturn(Val_unit);
}

CAMLprim value shexp_has_mkdirat() { return Val_true; }

CAMLprim value shexp_mkdirat(value v_dir, value v_path, value v_perm)
{
  CAMLparam3(v_dir, v_path, v_perm);
  int dir;
  char* path;
  int perm;
  int res;

  caml_unix_check_path(v_path, "mkdirat");
  dir  = Int_val(v_dir);
  path = caml_stat_strdup(String_val(v_path));
  perm = Int_val(v_perm);

  caml_enter_blocking_section();
  res = mkdirat(dir, path, perm);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (res == -1) uerror("mkdirat", v_path);
  CAMLreturn(Val_unit);
}

CAMLprim value shexp_has_unlinkat() { return Val_true; }

CAMLprim value shexp_unlinkat(value v_dir, value v_path, value v_flags)
{
  CAMLparam3(v_dir, v_path, v_flags);
  int dir;
  char* path;
  int flags;
  int res;

  caml_unix_check_path(v_path, "unlinkat");
  dir   = Int_val(v_dir);
  path  = caml_stat_strdup(String_val(v_path));
  flags = caml_convert_flag_list(v_flags, shexp_at_flag_table);

  caml_enter_blocking_section();
  res = unlinkat(dir, path, flags);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (res == -1) uerror("unlinkat", v_path);
  CAMLreturn(Val_unit);
}

#if defined(__APPLE__)

NA(mkfifoat)

#else

CAMLprim value shexp_has_mkfifoat() { return Val_true; }

CAMLprim value shexp_mkfifoat(value v_dir, value v_path, value v_perm)
{
  CAMLparam3(v_dir, v_path, v_perm);
  int dir;
  char* path;
  int perm;
  int res;

  caml_unix_check_path(v_path, "mkfifoat");
  dir  = Int_val(v_dir);
  path = caml_stat_strdup(String_val(v_path));
  perm = Int_val(v_perm);

  caml_enter_blocking_section();
  res = mkfifoat(dir, path, perm);
  caml_leave_blocking_section();

  caml_stat_free(path);
  if (res == -1) uerror("mkfifoat", v_path);
  CAMLreturn(Val_unit);
}

#endif

CAMLprim value shexp_has_linkat() { return Val_true; }

CAMLprim value shexp_linkat(value v_olddir, value v_oldpath, value v_newdir, value v_newpath, value v_flags)
{
  CAMLparam5(v_olddir, v_oldpath, v_newdir, v_newpath, v_flags);
  int olddir;
  char* oldpath;
  int newdir;
  char* newpath;
  int flags;
  int res;

  caml_unix_check_path(v_oldpath, "linkat");
  caml_unix_check_path(v_newpath, "linkat");
  olddir  = Int_val(v_olddir);
  oldpath = caml_stat_strdup(String_val(v_oldpath));
  newdir  = Int_val(v_newdir);
  newpath = caml_stat_strdup(String_val(v_newpath));
  flags   = caml_convert_flag_list(v_flags, shexp_at_flag_table);

  caml_enter_blocking_section();
  res = linkat(olddir, oldpath, newdir, newpath, flags);
  caml_leave_blocking_section();

  caml_stat_free(oldpath);
  caml_stat_free(newpath);
  if (res == -1) uerror("linkat", v_newpath);
  CAMLreturn(Val_unit);
}

CAMLprim value shexp_has_renameat() { return Val_true; }

CAMLprim value shexp_renameat(value v_olddir, value v_oldpath, value v_newdir, value v_newpath)
{
  CAMLparam4(v_olddir, v_oldpath, v_newdir, v_newpath);
  int olddir;
  char* oldpath;
  int newdir;
  char* newpath;
  int res;

  caml_unix_check_path(v_oldpath, "renameat");
  caml_unix_check_path(v_newpath, "renameat");
  olddir  = Int_val(v_olddir);
  oldpath = caml_stat_strdup(String_val(v_oldpath));
  newdir  = Int_val(v_newdir);
  newpath = caml_stat_strdup(String_val(v_newpath));

  caml_enter_blocking_section();
  res = renameat(olddir, oldpath, newdir, newpath);
  caml_leave_blocking_section();

  caml_stat_free(oldpath);
  caml_stat_free(newpath);
  if (res == -1) uerror("renameat", v_newpath);
  CAMLreturn(Val_unit);
}

CAMLprim value shexp_has_symlinkat() { return Val_true; }

CAMLprim value shexp_symlinkat(value v_oldpath, value v_newdir, value v_newpath)
{
  CAMLparam3(v_oldpath, v_newdir, v_newpath);
  char* oldpath;
  int newdir;
  char* newpath;
  int res;

  caml_unix_check_path(v_oldpath, "symlinkat");
  caml_unix_check_path(v_newpath, "symlinkat");
  oldpath = caml_stat_strdup(String_val(v_oldpath));
  newdir  = Int_val(v_newdir);
  newpath = caml_stat_strdup(String_val(v_newpath));

  caml_enter_blocking_section();
  res = symlinkat(oldpath, newdir, newpath);
  caml_leave_blocking_section();

  caml_stat_free(oldpath);
  caml_stat_free(newpath);
  if (res == -1) uerror("symlinkat", v_newpath);
  CAMLreturn(Val_unit);
}

#endif /* defined(_WIN32) */
